
DOUBLE_WIDE_TRADE_SKILLS = 1

local oldTradeSkillFrame_LoadUI = TradeSkillFrame_LoadUI
local oldTradeSkillFrame_Show
local SingleWideTradeSkillFrame_SetSelection

local TradeSkillFrameHDivLeft, 
      TradeSkillFrameHDivRight,
      TradeSkillFrameTopLeftTexture, 
      TradeSkillFrameTopRightTexture,
      DoubleWideTradeSkillFrameBottomTexture,
      DoubleWideTradeSkillFrametopTexture


local DoubleWideTradeSkillFrame_SetSelection

--[[
  Called when ever we need to convert single frame into the doublewide one
]]--
function DoubleWidenTradeSkillFrame()

  -- Widen the window, note that this size includes some pad on the right hand
  -- side after the scrollbars
  TradeSkillFrame:SetWidth(712);
  TRADE_SKILLS_DISPLAYED = 20
  TradeSkillFrame_SetSelection(GetTradeSkillSelectionIndex())
  
  TradeSkillFrame:SetAttribute("UIPanelLayout-area", "doublewide")

  TradeSkillListScrollFrame:ClearAllPoints();
  TradeSkillListScrollFrame:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 21, -96)
  TradeSkillListScrollFrame:SetHeight(311);

  -- Relocate the detail frame over to the right, and stretch it to full
  -- height.
  TradeSkillDetailScrollFrame:ClearAllPoints();
  TradeSkillDetailScrollFrame:SetPoint("TOPLEFT", TradeSkillListScrollFrame, "TOPRIGHT", 30, -2)
  TradeSkillDetailScrollFrame:SetWidth(298)
  TradeSkillDetailScrollFrame:SetHeight(310)
  --TradeSkillDetailScrollChildFrame:SetHeight(500)

  TradeSkillFrameCloseButton:ClearAllPoints();
  TradeSkillFrameCloseButton:SetPoint("TOPRIGHT", TradeSkillFrame, "TOPRIGHT", -29, -8);

  TradeSkillCancelButton:ClearAllPoints();
  TradeSkillCancelButton:SetPoint("CENTER", TradeSkillFrame, "BOTTOMRIGHT", -78, 91);

  TradeSkillCreateButton:ClearAllPoints();
  TradeSkillCreateButton:SetPoint("TOPRIGHT", TradeSkillCancelButton, "TOPLEFT", -1, 0)

  -- Now do some trickery to replace the backing textures
  TradeSkillFrameHDivLeft:Hide()
  TradeSkillFrameHDivRight:Hide()

  TradeSkillFrameTopRightTexture:SetWidth(256)
  TradeSkillFrameTopRightTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-TopRight]])
  TradeSkillFrameTopLeftTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-TopLeft]])
  TradeSkillFrameTopRightTexture:SetPoint("TOPRIGHT", TradeSkillFrame, "TOPRIGHT", 56, 0)

  TradeSkillFrameBottomRightTexture:SetWidth(256)
  TradeSkillFrameBottomRightTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-BotRight]])
  TradeSkillFrameBottomRightTexture:SetPoint("BOTTOMRIGHT", TradeSkillFrame, "BOTTOMRIGHT", 56, 0)

  TradeSkillFrameBottomLeftTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-BotLeft]])

  DoubleWideTradeSkillFrameTopTexture:Show()
  DoubleWideTradeSkillFrameBottomTexture:Show()

  --TradeSkillFrame_Update()

  local fix_scrollbar_textures = function(scrollbar)
     local rs = {scrollbar:GetRegions()}
     
     local r = rs[1]
     r:SetWidth(30)
     r:SetHeight(253)
     r:ClearAllPoints()
     r:SetPoint("TOPLEFT", scrollbar, "TOPRIGHT", -2, 2 )
     
     r:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]])
     r:SetTexCoord(0, 0.46875, 0.01171875, 1.0)
     r:Show()
     
     local r = rs[2]
     r:Show()
     r:SetWidth(30)
     r:SetHeight(108)
     r:ClearAllPoints()
     r:SetPoint("BOTTOMLEFT", scrollbar, "BOTTOMRIGHT", -2, -4 )
     r:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]])
     r:SetTexCoord(0.515625, 0.984375, 0, 0.421875)
  end

  fix_scrollbar_textures(TradeSkillListScrollFrame)
  fix_scrollbar_textures(TradeSkillDetailScrollFrame)

  -- Hook the click on the lhs to re-update the textures, since thats what default implementation does
  TradeSkillFrame_SetSelection = DoubleWideTradeSkillFrame_SetSelection
end

-- Unwiden the frame. Used for then TradeFrame is needed and both wont fit
function UnwidenTradeSkillFrame()
  TradeSkillFrame:SetWidth(384);
  TradeSkillFrame:SetAttribute("UIPanelLayout-area", "left")
  TradeSkillFrame_SetSelection = SingleWideTradeSkillFrame_SetSelection

  DoubleWideTradeSkillFrameBottomTexture:Hide()
  DoubleWideTradeSkillFrameTopTexture:Hide()

  TradeSkillFrameTopRightTexture:SetWidth(128)
  TradeSkillFrameTopRightTexture:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-TopRight]])
  TradeSkillFrameTopRightTexture:SetPoint("TOPRIGHT", TradeSkillFrame)
  TradeSkillFrameBottomRightTexture:SetWidth(128)
  TradeSkillFrameBottomRightTexture:SetPoint("BOTTOMRIGHT", TradeSkillFrame)

  TradeSkillFrameHDivLeft:Show()
  TradeSkillFrameHDivRight:Show()

  TradeSkillFrameCloseButton:ClearAllPoints();
  TradeSkillFrameCloseButton:SetPoint("TOPRIGHT", TradeSkillFrame, "TOPRIGHT", -29, -8);

  TradeSkillCancelButton:ClearAllPoints();
  TradeSkillCancelButton:SetPoint("CENTER", TradeSkillFrame, "TOPLEFT", 305, -422);

  for i = 9, 20 do
     local button = _G["TradeSkillSkill" .. i]
     button:Hide();
  end
  TRADE_SKILLS_DISPLAYED = 8

  local currentSkill = GetTradeSkillSelectionIndex()
  TradeSkillFrame_SetSelection(currentSkill)

  TradeSkillListScrollFrame:SetHeight(130)
  local rs = {TradeSkillListScrollFrame:GetRegions()}
   
  local r = rs[1]
  r:SetWidth(30)
  r:SetHeight(120)
  r:ClearAllPoints()
  r:SetPoint("TOPLEFT", TradeSkillListScrollFrame, "TOPRIGHT", -3, 2 )
  
  r:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-ScrollBar]])
  r:SetTexCoord(0, 0.46875, 0.0234375, 0.9609375)
  r:Show()
   
  local r = rs[2]
  r:Show()
  r:SetWidth(30)
  r:SetHeight(123)
  r:ClearAllPoints()
  r:SetPoint("BOTTOMLEFT", TradeSkillListScrollFrame, "BOTTOMRIGHT", -3, -2 )
  r:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-ScrollBar]])
  r:SetTexCoord(0.53125, 1.0, 0.03125, 1)

  --TradeSkillListScrollFrame:ClearAllPoints()
  --- /run UnwidenTradeSkillFrame()


  TradeSkillDetailScrollFrame:SetHeight(176)
  TradeSkillDetailScrollFrame:SetWidth(297)
  TradeSkillDetailScrollFrame:ClearAllPoints();
  TradeSkillDetailScrollFrame:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 20, -234)

  TradeSkillDetailScrollFrameTop:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-ScrollBar]])
  TradeSkillDetailScrollFrameTop:ClearAllPoints()
  TradeSkillDetailScrollFrameTop:SetPoint("TOPLEFT", TradeSkillDetailScrollFrame, "TOPRIGHT", -2, 5)
  TradeSkillDetailScrollFrameTop:SetTexCoord(0,0.46875,0,0.9609375)
  TradeSkillDetailScrollFrameTop:SetHeight(123)
  TradeSkillDetailScrollFrameTop:SetWidth(30)

  TradeSkillDetailScrollFrameBottom:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-ScrollBar]])
  TradeSkillDetailScrollFrameBottom:ClearAllPoints()
  TradeSkillDetailScrollFrameBottom:SetPoint("BOTTOMLEFT", TradeSkillDetailScrollFrame, "BOTTOMRIGHT", -2, -1)
  TradeSkillDetailScrollFrameBottom:SetTexCoord(0.53125,1,0.03125,1)
  TradeSkillDetailScrollFrameBottom:SetHeight(123)
  TradeSkillDetailScrollFrameBottom:SetWidth(30)

  --TradeSkillDetailScrollChildFrame:SetHeight(500)

  
end

DoubleWideTradeSkillFrame_SetSelection = function(id)
  SingleWideTradeSkillFrame_SetSelection(id)

  TradeSkillFrameBottomLeftTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-BotLeft]])

  if (IsTradeSkillLinked()) then
    DoubleWideTradeSkillFrameBottomTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-Link-Bot]])
    TradeSkillFrameBottomRightTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-Link-BotRight]])
  else
    TradeSkillFrameBottomRightTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-BotRight]])
    if (TradeSkillCreateButton:GetText() ~= CREATE) then
      DoubleWideTradeSkillFrameBottomTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-TwoButton-Bot]])
    else
      DoubleWideTradeSkillFrameBottomTexture:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-Bot]])
    end
  end

end

--[[
  If the res is 4:3, and insufficent UI scale, then there isn't enough space
  for doublewide frame + trade frame this is kinda important. So if needed,
  resize the tradeskill frame.

  We check this once the first time the TradeSkillUI addon is loaded.
]]--
local oldTradeFrame_OnEvent = TradeFrame_OnEvent
local function TradeFrame_OnEvent(frame, event, ...)
  if (event == 'TRADE_SHOW') then
    UnwidenTradeSkillFrame()
    UpdateUIPanelPositions()
  elseif (event == 'TRADE_CLOSED') then
    DoubleWidenTradeSkillFrame()
    UpdateUIPanelPositions()
  end
  oldTradeFrame_OnEvent(frame, event, ...)
    
end

-- OnLoad hooks for the TradeSkill frame.
TradeSkillFrame_LoadUI = function()
  oldTradeSkillFrame_LoadUI()

  if DOUBLE_WIDE_TRADE_SKILLS then

    SingleWideTradeSkillFrame_SetSelection = TradeSkillFrame_SetSelection

    -- One time only, don't have to redo when we go back to single-wide
    local oldTradeSkillsDisplayed = TRADE_SKILLS_DISPLAYED;
    TRADE_SKILLS_DISPLAYED = 20;

    for i = oldTradeSkillsDisplayed + 1, TRADE_SKILLS_DISPLAYED do
       local button = CreateFrame("Button", "TradeSkillSkill" .. i, TradeSkillFrame, "TradeSkillSkillButtonTemplate");
       button:SetID(i);
       button:Hide();
       button:ClearAllPoints();
       button:SetPoint("TOPLEFT", getglobal("TradeSkillSkill" .. (i-1)), "BOTTOMLEFT", 0, 1);
    end

    -- Give the un-named  textures local vars so we can refer to them easily
    local regions = { TradeSkillFrame:GetRegions() }

    for _,r in ipairs(regions) do
      if (r:IsObjectType("Texture")) then
        -- The Right hand side of the horiz sep bar doesn't have a name. Lame
        if (r:GetTexture() == [[Interface\ClassTrainerFrame\UI-ClassTrainer-HorizontalBar]]) then
          local src,_,dst,_,_ = r:GetPoint(1)
          if (src == "TOPLEFT" and dst == "TOPLEFT") then
            TradeSkillFrameHDivLeft  = r
          elseif (src == "LEFT" and dst == "RIGHT") then
            TradeSkillFrameHDivRight  = r
          end
        elseif (r:GetTexture()) then
          local which,vert,horz = r:GetTexture():match("^Interface\\[A-Za-z]+\\UI%-[A-Za-z]+%-(([A-Z][a-z]+)([A-Z][a-z]+))$")
          if (which == "TopLeft") then
            TradeSkillFrameTopLeftTexture = r
          elseif (which == "TopRight") then
            TradeSkillFrameTopRightTexture = r
          end
        end
      end
    end

    local region = TradeSkillFrame:CreateTexture(nil, "BACKGROUND")
    region:ClearAllPoints();
    region:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 256,0)
    region:SetWidth(256)
    region:SetHeight(256)
    region:SetTexCoord(0,1,0,1)
    region:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-Top]])
    region:Hide()
    DoubleWideTradeSkillFrameTopTexture = region

    region = TradeSkillFrame:CreateTexture(nil, "BACKGROUND")
    region:ClearAllPoints();
    region:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 256,-256)
    region:SetTexture([[Interface\Addons\DoubleWideTradeSkills\DWTS-Bot]])
    region:SetTexCoord(0,1,0,1)
    region:SetWidth(256)
    region:SetHeight(256)
    region:Hide()
    DoubleWideTradeSkillFrameBottomTexture = region

    -- re-adjust the points so that these controls are tied to the LHS of the window only
    TradeSkillInvSlotDropDown:ClearAllPoints()
    TradeSkillSubClassDropDown:ClearAllPoints()
    TradeSkillSubClassDropDown:SetPoint("TOPLEFT", TradeSkillExpandButtonFrame, "TOPRIGHT", -15, 5)
    TradeSkillInvSlotDropDown:SetPoint("LEFT", TradeSkillSubClassDropDown, "RIGHT", -35, 0)

    TradeSkillFrameEditBox:ClearAllPoints()
    TradeSkillFrameEditBox:SetPoint("BOTTOMLEFT", TradeSkillInvSlotDropDown, "TOPLEFT", 25, -2)
    TradeSkillFrameEditBox:Hide()

    TradeSkillRankFrameSkillRank:ClearAllPoints()
    TradeSkillRankFrameSkillRank:SetPoint("CENTER", TradeSkillRankFrame, "CENTER", -16, 1)

    DoubleWidenTradeSkillFrame()

    UIPanelWindows["TradeSkillFrame"]["area"] = "doublewide"


    local width = GetScreenWidth()
    if ( width < 1296 ) then -- Emperical testing of value needed to show both windows
      _G["TradeFrame_OnEvent"] = TradeFrame_OnEvent
    end
  end

  TradeSkillFrame_LoadUI = oldTradeSkillFrame_LoadUI
end


