local addon = CreateFrame("Frame", nil, UIParent)
-- frame
local frame_anchor = "TOPRIGHT"
local frame_x = -10
local frame_y = -4
-- font
local font = "Fonts\\2002.TTF"
local size = 11
local outline = true
local shadow = true
local class = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
local color = { r=class.r, g=class.g, b=class.b }
local text_anchor = "TOPRIGHT"
-- used locals
local x, y, text, zone
-- new
function addon:new()
	-- frame position
	self:SetPoint(frame_anchor, UIParent, frame_anchor, frame_x, frame_y)
	self:SetWidth(50)
	self:SetHeight(13)
	-- create fontstring
	text = self:CreateFontString(nil, "OVERLAY")
	-- text style
	if outline == true then
		flag = "OUTLINE"
	else
		flag = nil
	end
	text:SetFont(font, size, flag)
	text:SetTextColor(color.r, color.g, color.b)
	if shadow == true then
		text:SetShadowOffset(1, -1)
	end
	text:SetPoint(text_anchor, self)
	
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	
	-- update
	self:SetScript("OnUpdate", self.update) 
	self:SetScript("OnEvent", self.event)
end
function addon:event()
	if (event == "ZONE_CHANGED_NEW_AREA") then 
		SetMapToCurrentZone()
	end
end
-- update function
function addon:update()
	-- get zone map
	zone = GetMinimapZoneText()
	zone = "|c00ffffff"..zone.."|r"
	-- get player x,y
	x, y = GetPlayerMapPosition("player")
	-- if x and y 0 then boo
	if(x == 0 and y == 0) then
		coords = "";
	else
		coords = " "..format("%.2d.%.2d",x*100,y*100)
	end
	-- set it
	text:SetText(zone..coords) 
end
-- fire
addon:new()