﻿--[[
	VERSION 1.6.2 by Lyn
	CREDITS: evl and his awesome evl_clock to get lynstats "ace-less" 
--]]
local addon = CreateFrame("Button", "LynStats", UIParent)

--
-- the x-files aka. configuration
--
-- frame
local frame_anchor = "TOP" -- LEFT, TOPLEFT, TOP, TOPRIGHT, RIGHT, CENTER, BOTTOMRIGHT, BOTTOM, BOTTOMLEFT
local pos_x = 0
local pos_y = -5
-- text
local text_anchor = "TOPLEFT"
local font = "Fonts\\2002B.ttf"
local size = 10
local addonlist = 30 -- how much addons should be shown?
local classcolors = true -- true or false
local shadow = true -- true / false
local outline = true -- true / false
local time24 = false -- true: 24h / false: 12h
-- tooltip
local tip_anchor = "BOTTOMRIGHT"
local tip_x = -90
local tip_y = 200


-- reinforcements!
local color, mail, hasmail, ticktack, lag, fps, ep, xp_cur, xp_max, text, blizz, memory, entry, i, nr, xp_rest, ep, moneys, bags, before, after

if classcolors == true then
	color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
else
	color = { r=0, g=0.8, b=1 } -- own textcolor
end

-- format memory stuff
local memformat = function(number)
	if number > 1024 then
		return string.format("%.2f mb", (number / 1024))
	else
		return string.format("%.1f kb", floor(number))
	end
end

-- garbage
-- inspired by naevx, thanks.
local cleargarbage = function()
	UpdateAddOnMemoryUsage()
	before = gcinfo()
	collectgarbage()
	UpdateAddOnMemoryUsage()
	after = gcinfo()
	ChatFrame1:AddMessage("|c0000ccffCleaned:|r "..memformat(before-after))
end

-- ordering
local addoncompare = function(a, b)
	return a.memory > b.memory
end

-- the allmighty
function addon:new()
	text = self:CreateFontString(nil, "OVERLAY")
	if outline == true then
		text:SetFont(font, size, "OUTLINE")
	else
		text:SetFont(font, size, nil)
	end
	if shadow == true then
		text:SetShadowOffset(1,-1)
	end
	text:SetPoint(text_anchor, self)
	text:SetTextColor(color.r, color.g, color.b)

	self:SetPoint(frame_anchor, UIParent, frame_anchor, pos_x, pos_y)
	self:SetWidth(50)
	self:SetHeight(13)
	
	self:SetScript("OnUpdate", self.update)
	self:SetScript("OnEnter", self.enter)
	self:SetScript("OnLeave", function() GameTooltip:Hide() end)
	self:SetScript("OnClick", function() cleargarbage() end)
end

-- update
local last = 0
function addon:update(elapsed)
	last = last + elapsed

	if last > 1 then
		--[[ mail stuff
		hasmail = (HasNewMail() or 0);
		if hasmail > 0 then
			mail = "|c00FA58F4new!|r  "
		else
			mail = ""
		end]]
		
		-- date thingy
		if time24 == true then
			ticktack = date("%H:%M")
		else
			ticktack = date("%I:%M %p")
		end
		ticktack = "|c00ffffff"..ticktack.."|r"
		
		-- fps crap
		fps = GetFramerate()
		fps = "|c00ffffff"..floor(fps).."|rfps  "
		
		-- right down downright + punch
		lag = select(3, GetNetStats())
		lag = "|c00ffffff"..lag.."|rms  "
		
		-- xp stuff
		xp_cur = UnitXP("player")
		xp_max = UnitXPMax("player")
		xp_rest = GetXPExhaustion("player") or nil
		if UnitLevel("player") < MAX_PLAYER_LEVEL then
			ep = "|c00ffffff"..floor(xp_max - xp_cur).."|r"
			if xp_rest ~= nil then	
				ep = ep.."xp|c0000ccff(R)|r |c00ffffff"..floor(xp_cur / xp_max * 100).."|r%  "
			else
				ep = ep.."xp |c00ffffff"..floor(xp_cur / xp_max * 100).."|r%  "
			end
		else
			ep = ""
		end
		
		--[[ bags
		used = 0 
		maximum = 0
		  for bag=0,4 do
		  if GetBagName(bag) and select(8, GetItemInfo(GetBagName(bag))) ~= "INVTYPE_QUIVER" then
           for slot=1,GetContainerNumSlots(bag) do
            if (GetContainerItemLink(bag,slot)) then
			 used = used + 1
			 maximum = GetContainerNumSlots(0) + GetContainerNumSlots(1) + GetContainerNumSlots(2) + GetContainerNumSlots(3) + GetContainerNumSlots(4)
			 bags = "|c00ffffff"..used.."|r / |c00ffffff"..maximum.."|r Bags  "
			end
		   end
		  end
		  end
		]]--
		
		--bling, bling, money $$
		local function money()
			if strlen(GetMoney()) > 4 then
				start, ende, gold, silver, copper = string.find(GetMoney(),"(%d+)(%d.)(%d.)")
			elseif strlen(GetMoney()) > 2 then
				start, ende, silver, copper = string.find(GetMoney(),"(%d.)(%d.)")
				gold = 0
			else
				start, ende, copper = string.find(GetMoney(),"(%d.)")
				gold = 0
				silver = 0
			end
		return tonumber(gold,10), tonumber(silver,10), tonumber(copper,10)	
		end
			copper = select(3,money())
			silver = select(2,money())
			gold = select(1,money())
			moneys = "|c00ffffff"..gold.."|r|cFFFFB311g|r |c00ffffff"..silver.."|r|cFFE1D3CBs|r |c00ffffff"..copper.."|r|cFFE16B47c|r  "
		
		-- reset timer
		last = 0
		
		-- the magic!
		text:SetText(moneys..fps..lag..ep..ticktack)
		self:SetWidth(text:GetStringWidth())
	end
end

--[[
	ADDON LIST
--]]
function addon:enter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint(tip_anchor, UIParent, tip_anchor, tip_x, tip_y)
	blizz = collectgarbage("count")
	addons = {}
	total = 0
	nr = 0
	UpdateAddOnMemoryUsage()
	if time24 == true then
		ticktack = date("%H.%M")
	else
		ticktack = date("%I.%M")
	end
	hours, minutes = GetGameTime()
	GameTooltip:AddDoubleLine(ticktack, string.format("%02d", hours).."."..string.format("%02d", minutes), 1, 1, 1, 1, 1, 1)
	GameTooltip:AddDoubleLine("로컬 시간", "서버 시간", color.r, color.g, color.b, color.r, color.g, color.b)
	GameTooltip:AddLine(" ")
	for i=1, GetNumAddOns(), 1 do
		if (GetAddOnMemoryUsage(i) > 0 ) then
			memory = GetAddOnMemoryUsage(i)
			entry = {name = GetAddOnInfo(i), memory = memory}
			table.insert(addons, entry)
			total = total + memory
		end
	end
	table.sort(addons, addoncompare)
	for _, entry in pairs(addons) do
		if nr < addonlist then
			GameTooltip:AddDoubleLine(entry.name, memformat(entry.memory), 1, 1, 1, 1, 1, 1)
			nr = nr+1
		end
	end
	GameTooltip:AddLine(" ")
	GameTooltip:AddDoubleLine("전체", memformat(total), color.r, color.g, color.b, color.r, color.g, color.b)
	GameTooltip:AddDoubleLine("Blizz 메모리 사용량 포함", memformat(blizz), color.r, color.g, color.b, color.r, color.g, color.b)
	GameTooltip:Show()
end

-- and... go!
addon:new()