﻿MAX_QUEST_WATCH_TIME = 3600;
QUEST_WATCH_NO_EXPIRE = 1;
MAX_WATCHABLE_QUESTS = 15;

local function QLE_GetRegions(...)
    local regions = {} 
    for i = 1, select('#', ...) do
        regions[i] = select(i, ...)
    end
    return regions;
end

--------------------------- QuestLogFrame Modify ---------------------------------
do
  local layers={};
  for _,region in ipairs(QLE_GetRegions(QuestLogFrame:GetRegions())) do
      if region:GetObjectType()=="Texture" then
          if region:GetDrawLayer()=="ARTWORK" then
              table.insert(layers,region);
          end
      end
  end
  for i,v in ipairs(layers) do
      if string.find(v:GetTexture(),"TopLeft") then
          v:SetDrawLayer("BACKGROUND");
          v:SetTexture("Interface\\helpframe\\helpframe-topleft");
      elseif string.find(v:GetTexture(),"TopRight") then
          v:SetDrawLayer("BACKGROUND");
          v:SetTexture("Interface\\helpframe\\helpframe-topright");
      elseif string.find(v:GetTexture(),"BotLeft") then
          v:SetDrawLayer("BACKGROUND");
          v:SetTexture("Interface\\helpframe\\helpframe-botleft");
      else
          v:SetDrawLayer("BACKGROUND");
          v:SetTexture("Interface\\helpframe\\helpframe-botright");
      end
  end
  
  for i=7,25 do
      if not getglobal("QuestLogTitle"..i) then
          local f=CreateFrame("Button","QuestLogTitle"..i,QuestLogFrame,"QuestLogTitleButtonTemplate");
          f:SetID(i);
          f:SetPoint("TOPLEFT",getglobal("QuestLogTitle"..i-1),"BOTTOMLEFT",0,1);
      end
  end
  
  QUESTS_DISPLAYED = 25;
  QuestLogFrame:SetWidth(730);
  QuestLogFrame:SetHeight(512);
  QuestLogFrame:SetHitRectInsets(0,0,0,0);
  QuestLogListScrollFrame:SetWidth(300);
  QuestLogListScrollFrame:SetHeight(412);
  QuestLogListScrollFrame:SetPoint("TOPLEFT",QuestLogFrame,19,-53);
  QuestLogDetailScrollFrame:SetWidth(300);
  QuestLogDetailScrollFrame:SetHeight(412);
  QuestLogDetailScrollFrame:SetPoint("TOPLEFT",QuestLogListScrollFrame,"TOPRIGHT",32,0);
  local ft = QuestLogFrame:CreateTexture();
  ft:SetDrawLayer("BACKGROUND");
  ft:SetTexture("Interface\\helpframe\\helpframe-top");
  ft:SetWidth(256);
  ft:SetHeight(256);
  ft:SetPoint("TOPLEFT",256,0);
  local ft = QuestLogFrame:CreateTexture();
  ft:SetDrawLayer("BACKGROUND");
  ft:SetTexture("Interface\\helpframe\\helpframe-bottom");
  ft:SetWidth(256);
  ft:SetHeight(256);
  ft:SetPoint("BOTTOMLEFT",256,0);
  local ft = QuestLogFrame:CreateTexture();
  ft:SetDrawLayer("BACKGROUND");
  ft:SetTexture("Interface\\helpframe\\helpframe-top");
  ft:SetWidth(90);
  ft:SetHeight(256);
  ft:SetPoint("TOPLEFT",512,0);
  ft:SetTexCoord(0,0.35,0,1);
  local ft = QuestLogFrame:CreateTexture();
  ft:SetDrawLayer("BACKGROUND");
  ft:SetTexture("Interface\\helpframe\\helpframe-bottom");
  ft:SetWidth(90);
  ft:SetHeight(256);
  ft:SetPoint("BOTTOMLEFT",512,0);
  ft:SetTexCoord(0,0.35,0,1);
  local ft = QuestLogDetailScrollFrame:CreateTexture();
  ft:SetDrawLayer("BACKGROUND");
  ft:SetTexture("Interface\\Stationery\\StationeryTest1");
  ft:SetWidth(300);
  ft:SetHeight(412);
  ft:SetPoint("TOPLEFT",0,0);
--  ft:SetVertexColor(0,1,1);
  QuestLogDetailScrollFrame.texture=ft;
  QuestLogFrameCloseButton:SetPoint("TOPRIGHT",QuestLogFrame,"TOPRIGHT",-42,-3);
  QuestLogFrameAbandonButton:SetPoint("BOTTOMLEFT",QuestLogFrame,"BOTTOMLEFT",12,22);
  QuestFrameExitButton:SetPoint("BOTTOMRIGHT",QuestLogFrame,"BOTTOMRIGHT",-54,22);
  QuestLogExpandButtonFrame:SetPoint("TOPLEFT",QuestLogFrame,"TOPLEFT",70,-27);
  QuestLogTitleText:SetPoint("TOP",QuestLogFrame,0,-25);
  
  local function User_QuestLogUpdateQuestCount()
      local p,t,rp,x,y = QuestLogCount:GetPoint();
      QuestLogCount:SetPoint(p,t,rp,x-38,y+20);
  end
  hooksecurefunc("QuestLogUpdateQuestCount",User_QuestLogUpdateQuestCount)
end

--------------------- QuestWatchFrame Modify -------------------------------------
do
  QuestWatchFrameLoc = {};
  local f = CreateFrame("Frame","QuestWatchFrameBorder",UIParent);
  f:Hide();
  f:EnableMouse(true);
  f:SetMovable(true);
  f:SetResizable(true);
  f:SetClampedToScreen(true);
  f:RegisterForDrag("LeftButton");
  f:SetScript("OnDragStart",
      function (self)
        if ( not QuestWatchFrameLoc.lock ) then
          self:StartMoving();
          self.isMoving = true;
        end
  end);
  f:SetScript("OnDragStop",
      function (self)
          self:StopMovingOrSizing();
          self.isMoving = false;
          QuestWatchFrameLoc.x = self:GetRight();
          QuestWatchFrameLoc.y = self:GetTop();
  end);
  f:SetFrameStrata("BACKGROUND");
  f:SetPoint("TOPRIGHT",MinimapCluster,"BOTTOMRIGHT",0,-10);
  f:SetBackdrop({
          bgFile="Interface\\Characterframe\\UI-Party-Background",
          edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
          tile=1, tileSize=16, edgeSize=16,
          insets={left=5, right=5, top=5, bottom=5}
  });
  f:SetBackdropColor(0,0,0,QuestWatchFrameLoc.a);
  f:SetScript("OnEvent",function(self)
    self:SetBackdropColor(0,0,0,QuestWatchFrameLoc.a);
    if (QuestWatchFrameLoc.border) then
      QuestWatchFrameBorder:SetBackdropBorderColor(0,0,0,0);
    else
      QuestWatchFrameBorder:SetBackdropBorderColor(1,1,1,1);
    end
  end);
  f:RegisterEvent("VARIABLES_LOADED");
  QuestWatchQuestName:SetParent(f);
  for i=1,30 do
    getglobal("QuestWatchLine"..i):SetParent(f);
  end
  QuestWatchLine1:ClearAllPoints();
  QuestWatchLine1:SetPoint("TOPLEFT",f,"TOPLEFT",10,-13);

  local function User_QuestWatch_Update()
    if (not QuestWatchFrameLoc.x) then
      QuestWatchFrameLoc.x = QuestWatchFrame:GetRight()-10;
      QuestWatchFrameLoc.y = QuestWatchFrame:GetTop();
      QuestWatchFrameLoc.a = 0.3;
    end
    ----------- Resizing QuestWatchFrameBorder ----------------------------
    QuestWatchFrameBorder:ClearAllPoints();
    QuestWatchFrameBorder:SetPoint("TOPRIGHT",UIParent,"BOTTOMLEFT",QuestWatchFrameLoc.x,QuestWatchFrameLoc.y);
    if QuestWatchFrame:IsVisible() then
      QuestWatchFrameBorder:Show();
    else
      QuestWatchFrameBorder:Hide();
    end
    ------------ Make up QuestWatchFrame's text   --------------------------
    local watchTextIndex = 1;
    local textWidth = 0;
    for i=1, GetNumQuestWatches() do
        local questIndex = GetQuestIndexForWatch(i);
        if (questIndex) then
          local numObjectives = GetNumQuestLeaderBoards(questIndex);
          if (numObjectives > 0) then
            local title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questIndex);
            local color = GetDifficultyColor(level);
            if ( isComplete and isComplete < 0 ) then
              questTag = FAILED;
            elseif ( isComplete and isComplete > 0 ) then
              questTag = COMPLETE;
              if QLE_AutoRemoveQuestWatch then 
                RemoveQuestWatch(questIndex);
              end;
            elseif (isDaily) then 
              if (questTag) then 
                questTag=format(DAILY_QUEST_TAG_TEMPLATE, questTag);
              else
                questTag=DAILY;
              end
            end
            if ( questTag ) then 
              QuestWatchFrameBorder:SetWidth(QuestWatchFrameBorder:GetWidth()+strlen(questTag));  
              questTag="|cffff9C00("..questTag..")|r ";
            end;
            watchText = getglobal("QuestWatchLine"..watchTextIndex);
            watchText:SetText("["..level.."] "..(questTag or "")..watchText:GetText());
            watchText:SetTextColor(color.r,color.g,color.b);
            textWidth=max(watchText:GetStringWidth(),textWidth)
            local objectivesCompleted = 0;
            for j=1,numObjectives do
              watchText = getglobal("QuestWatchLine"..watchTextIndex+j);
              local _, _, finished = GetQuestLogLeaderBoard(j, questIndex);
              if finished then
                watchText:SetTextColor(GREEN_FONT_COLOR.r, GREEN_FONT_COLOR.g, GREEN_FONT_COLOR.b);
                objectivesCompleted = objectivesCompleted + 1;
              end
              textWidth=max(watchText:GetStringWidth(),textWidth)
            end
            watchText = getglobal("QuestWatchLine"..watchTextIndex);
            if objectivesCompleted == numObjectives then
                watchText:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
            end
            watchTextIndex = watchTextIndex + numObjectives +1; 
          end
        end
    end
    QuestWatchFrameBorder:SetWidth(max(QuestWatchFrame:GetWidth(),textWidth)+20);
    QuestWatchFrameBorder:SetHeight(QuestWatchFrame:GetHeight()+25);
  end

  hooksecurefunc("QuestWatch_Update",User_QuestWatch_Update);
end

---------------------- Display Quest Level ----------------------------------------
do
  local function User_QuestLog_Update()
    local numEntries, numQuests = GetNumQuestLogEntries();
    for i = 1, QUESTS_DISPLAYED, 1 do
      local questIndex = i + FauxScrollFrame_GetOffset( QuestLogListScrollFrame );
      local questLogTitle = getglobal( "QuestLogTitle" .. i );
      local questCheck = getglobal( "QuestLogTitle" .. i .. "Check" );
      if ( questIndex <= numEntries ) then
        local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questIndex);
        if ( level > 0 ) then
          questLogTitle:SetText( "[" .. level .. "] " .. questLogTitleText );
          QuestLogDummyText:SetText("[" .. level .. "] "..questLogTitleText);
          questCheck:ClearAllPoints();
          questCheck:SetPoint( "LEFT", questLogTitle,"LEFT", -1, 0 );
        end
      end
    end
  end
  hooksecurefunc("QuestLog_Update",User_QuestLog_Update);
end

----------------------- Display Quest Tag in ChatFrame ----------------------------
org_QuestLogTitleButton_OnClick=QuestLogTitleButton_OnClick;
function QuestLogTitleButton_OnClick(self,button)
  local questIndex = self:GetID() + FauxScrollFrame_GetOffset(QuestLogListScrollFrame);
  if ( IsModifiedClick("CHATLINK") and ChatFrameEditBox:IsVisible() ) then
    local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questIndex);
    local questLink = GetQuestLink(questIndex);
    if ( level > 0 ) then
      if (isDaily) then 
        if (questTag) then 
          questTag=format(DAILY_QUEST_TAG_TEMPLATE, questTag);
        else
          questTag=DAILY;
        end
      end
      if ( questTag ) then 
        questTag="("..questTag..") ";
      end;
      ChatEdit_InsertLink("["..level.."] "..(questTag or "")..questLink);
    end
    return;
  end
  org_QuestLogTitleButton_OnClick(self,button);
end

------------------------------- Quest Announce ------------------------------------
do
  QLE_EnableAnnounce = true;
  completedQuestIndex = nil;
  QuestLogFrame:RegisterEvent("UI_INFO_MESSAGE");
  QuestLogFrame:RegisterEvent("CHAT_MSG_SYSTEM");
  QuestLogFrame:HookScript("OnEvent",function(self,event,...)
    if not QLE_EnableAnnounce then return end;
    if event=="UI_INFO_MESSAGE" then
      if (arg1) and string.find(arg1,":") then
        if GetNumPartyMembers()>0 then
          SendChatMessage(arg1,"PARTY");
--        else
--          SendChatMessage(arg1,"WHISPER",nil,UnitName("player"));
        end
      end
    end
    if event == "QUEST_WATCH_UPDATE" then
      completedQuestIndex=arg1;
      return
    end
    if event == "QUEST_LOG_UPDATE" and completedQuestIndex then
      local msg;
      local questLogTitleText, level, _, _, isHeader, _, isComplete, _ = GetQuestLogTitle(completedQuestIndex);
      if (isComplete) then
        if (isComplete>0) then
           msg = "[" .. level .. "] " ..questLogTitleText.." : 완료";
		   PlaySoundFile("Sound\\Creature\\Peon\\PeonBuildingComplete1.wav");
        else
           msg = "[" .. level .. "] " ..questLogTitleText.." : 실패";
        end
        if GetNumPartyMembers()>0 then
          SendChatMessage(msg,"PARTY");
--        else
--          SendChatMessage(msg,"WHISPER",nil,UnitName("player"));
        end 
      end
      completedQuestIndex=nil;
    end
    if event == "CHAT_MSG_SYSTEM" and arg1:match(ERR_QUEST_ACCEPTED_S:match("^(.+):")) then
      msg = arg1;
      if GetNumPartyMembers()>0 then
        SendChatMessage(msg,"PARTY");
--      else
--        SendChatMessage(msg,"WHISPER",nil,UnitName("player"));
      end 
    end
  end);
end

-------------------------------slash command --------------------------------------
do
  SLASH_QLExpand1 = "/qle";
  SlashCmdList["QLExpand"] = function(cmd)
    local param1, param2 = cmd:match("^([^%s]+)%s*(.*)$");
    param1 = (param1 and param1:lower() or cmd:lower());
    if param1 == "alpha" then
      local alpha=tonumber(param2);
      if (alpha>=0 and alpha<=1) then
        QuestWatchFrameLoc.a=alpha;
        QuestWatchFrameBorder:SetBackdropColor(0,0,0,alpha);
        DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r 퀘스트추적창의 배경투명도가 "..alpha.." 로 변경되었습니다.");
      else
        DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r 잘못된 투명도 값입니다.(0 ~ 1 사이값)");
      end
    elseif param1 == "border" then
      QuestWatchFrameLoc.border = not QuestWatchFrameLoc.border;
      if (QuestWatchFrameLoc.border) then
        QuestWatchFrameBorder:SetBackdropBorderColor(0,0,0,0);
      else
        QuestWatchFrameBorder:SetBackdropBorderColor(1,1,1,1);
      end
    elseif param1 == "an" or param1=="알림" then
      QLE_EnableAnnounce = not QLE_EnableAnnounce;
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r 퀘스트 진행상황 알림 기능이 "..(QLE_EnableAnnounce and "[활성화] 되었습니다." or "[중지] 되었습니다."));
    elseif param1 == "auto" then
      QLE_AutoRemoveQuestWatch = not QLE_AutoRemoveQuestWatch;
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r 퀘스트 완료시 추적창 자동 제거 기능이 "..(QLE_AutoRemoveQuestWatch and "[활성화] 되었습니다." or "[중지] 되었습니다."));
    elseif param1 == "watch" then
      QuestWatchFrameBorder:ClearAllPoints();
      QuestWatchFrameBorder:SetPoint("CENTER",UIParent,"CENTER",0,0);
      QuestWatchLine1:ClearAllPoints();
      QuestWatchLine1:SetPoint("TOPLEFT",QuestWatchFrameBorder,"TOPLEFT",10,-13);
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r 퀘스트 추적창위치가 화면 중앙으로 초기화 되었습니다.");
    elseif param1 == "lock" then
      QuestWatchFrameLoc.lock = not QuestWatchFrameLoc.lock;
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r 퀘스트 추적창 위치 이동 "..( QuestWatchFrameLoc.lock and "고정됨" or "고정 해제됨" ) ); 
    else
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r 사용법 :");
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r /qle alpha <0~1> : 추적창 배경 투명도 조절");
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r /qle border : 추적창 외곽선 보이기/숨기기 토글");
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r /qle an : 파티채널에 퀘스트 진행상황 알림 On/Off");
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r /qle auto : 퀘스트 완료시 추적창 자동 제거 기능 On/Off");
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r /qle watch : 퀘스트 추적창 위치 초기화");
      DEFAULT_CHAT_FRAME:AddMessage("|cffffff00QLExpand-> |r /qle lock : 퀘스트 추적창 위치 고정/해제");
    end
  end
end

------------------------------- Display QID ---------------------------------------
do
  function GetQID(index)
    local qlink=GetQuestLink(index) or "";
    return qlink:match("|h([^|]+)|h"), tonumber((qlink:match("|Hquest:(%d+)")));
  end
  
  function QLE_QuestLogTitleButton_OnEnter()
    if this.isHeader then return end;
    local index = this:GetID() + FauxScrollFrame_GetOffset(QuestLogListScrollFrame);
    GameTooltip:SetOwner(this,"ANCHOR_CURSOR");
    GameTooltip:SetText("QID : "..select(2,GetQID(index)));
  end
--  hooksecurefunc("QuestLogTitleButton_OnEnter",QLE_QuestLogTitleButton_OnEnter);
end
