-- 
-- OPTIONS // 1 is enabled // 0 is disabled 

local show_questlevels = 1  -- show the questlevel in front of the questname
local color_tooltip = 1  -- colorize tooltip text with the RGB values below
local color_r = 1.0
local color_g = 0.8
local color_b = 0.0
local show_green_questname_when_q_completed = 1 -- shows the line in green when you killed/gathered x/x things
local add_tooltip_line = 0  -- adds a free line between the addon's questline and the standard text

-- END OF OPTIONS - DON'T CHANGE ANYTHING BELOW 




local k
local j


function decToHex(Dec, Length)
	local B, K, Hex, I, D = 16, "0123456789ABCDEF", "", 0;
	while Dec>0 do
		I=I+1;
		Dec, D = math.floor(Dec/B), math.fmod(Dec,B)+1;
		Hex=string.sub(K,D,D)..Hex;
	end
	if( (Length ~= nil) and (string.len(Hex) < Length) ) then
		local temp, i = Length-string.len(Hex), 1;
		for i=1, temp, 1 do
			Hex = "0"..Hex;
		end
	end
	return Hex;
end

function TooltipQuestMob_ColorText(t, r, g, b)
	if ( t == nil ) then t = ""; end
	if ( r == nil ) then r = 0.0; end
	if ( g == nil ) then g = 0.0; end
	if ( b == nil ) then b = 0.0; end
	return "|CFF"..decToHex(r*255, 2)..decToHex(g*255, 2)..decToHex(b*255, 2)..t.."|r";
end

function TooltipQuestMob_Tooltip_OnLoad()
	-- this will catch mobs needed for quests
	this:RegisterEvent('UPDATE_MOUSEOVER_UNIT');
	
	-- this should catch items when you're going to sell them
	TooltipQuestMob_ContainerFrameItemButton_OnEnter = ContainerFrameItemButton_OnEnter;
	ContainerFrameItemButton_OnEnter = TooltipQuestMob_New_ContainerFrameItemButton_OnEnter;
end


function TooltipQuestMob_Tooltip_OnEvent(event)
    if (event == 'UPDATE_MOUSEOVER_UNIT') then
		TooltipQuestMob_ScanTooltip();
    end
end



-- New function for container items
function TooltipQuestMob_New_ContainerFrameItemButton_OnEnter(self)
	-- call old function
	TooltipQuestMob_ContainerFrameItemButton_OnEnter(self);
	TooltipQuestMob_ScanTooltip();
end

function TooltipQuestMob_ScanTooltip()
    if ( GameTooltip ~= nil and
				 getglobal('GameTooltipTextLeft1'):IsVisible() and
				 getglobal('GameTooltipTextLeft1'):GetText() ~= nil ) then

			return TooltipQuestMob_ScanTooltipItem(getglobal('GameTooltipTextLeft1'):GetText());

    end
		
		return false;
end



function TooltipQuestMob_ScanTooltipItem(queryString)
	if(queryString == nil) then return false; end
	
	local oldSelection = GetQuestLogSelection();
	--	if(oldSelection < 1) then oldSelection = 1; end
		
	local questID;
	local numEntries, numQuests = GetNumQuestLogEntries();
	local questTitle, level, questTag, isHeader;
	local numObjectives, questObjectives, questDescription;
	local found = false;
	local text, typ, finished;
	local x = nil;
	
	-- loop through all quests
	for i=1, numEntries, 1 do
		questID = i;
		questTitle, level, questTag, _, isHeader = GetQuestLogTitle(questID);
		x = nil;
		
		if (not isHeader) then
			SelectQuestLogEntry(questID);
			if(questTitle) then				
				numObjectives = GetNumQuestLeaderBoards();
				if(numObjectives > 0) then	
					-- loop through all objectives
					for j=1, numObjectives, 1 do
						text, typ, finished = GetQuestLogLeaderBoard(j);
						if(not text or strlen(text) == 0) then
							text = typ;
						end
						
						x = string.find(text, queryString);
						
						if (x ~= nil) then
							found = true;
						end
						
						if(found) then
							break;
						end
					end -- loop through all objectives
				end	
				
				
				if ( x ~= nil ) then
					local completion = nil;
					if ( numObjectives > 0 ) then
						for y, z in string.gmatch(text, "(%d+)/(%d+)") do
							completion = "   ("..y.."/"..z..")";
							k = y
							j = z
						end
					end
					
					
					if ( show_questlevels == 1 ) then
						if(questTag ~= NIL) then
							level = level.."+"
					 	end
						questTitle = "["..level.."] "..questTitle;
					end
					
					if (completion ~= nil) then
						questTitle = questTitle..completion;
					end

					if ( color_tooltip == 1 ) then
						if (j == k) then
							if ( show_green_questname_when_q_completed == 1) then
								questTitle = TooltipQuestMob_ColorText(questTitle, 0, 1, 0);
							end
						else
							questTitle = TooltipQuestMob_ColorText(questTitle, color_r, color_g, color_b);
						end
					end
					
					
					-- add tooltip line
					if ( add_tooltip_line == 1 ) then
						GameTooltip:AddLine(" ", 1, 1, 1, 1);
						GameTooltip:AddLine(questTitle, 1, 1, 1, 1);	
						GameTooltip:SetHeight(GameTooltip:GetHeight() + 28);
					else
						GameTooltip:AddLine(questTitle, 1, 1, 1, 1);	
						GameTooltip:SetHeight(GameTooltip:GetHeight() + 14);
					end
					
					
					-- resize tooltip
					leng = getglobal(GameTooltip:GetName() .. "TextLeft" .. GameTooltip:NumLines()):GetStringWidth();
					leng = leng + 22;
				
					if ( leng > GameTooltip:GetWidth() ) then
						GameTooltip:SetWidth(leng);
					end
				end
			end
		end
		
	end -- loop through all quests
	
end

-- 
-- Most of the code was taken from EQL Unofficial by DanielRehn (http://ui.worldofwar.net/ui.php?id=1676)
-- I added some things and rewrote it a bit.
-- Thx to tromboneux @ curse for the quick 2.2 fix
-- Beutju

-- 
