--[[
cargBags Standard Handler
	
	This handler is used by default and gets the data directly from the WoW API
]]

local handler = {}
local _G = getfenv(0)
local wotlk = select(4, GetBuildInfo()) >= 3e4

local func = function(t, self, i, ...)
	if(t[i]) then
		return t[i](...)
	elseif(_G[i]) then
		return _G[i](...)
	end
end

handler.name = "Standard Handler"

handler.Init = function(self)
	if(self.Money) then
		if(wotlk) then
			MoneyFrame_SetType(self.Money, "PLAYER")
		else
			MoneyFrame_SetType("PLAYER", self.Money)
		end
	end
end

handler = setmetatable(handler, {__call = func})
cargBags.Handler['Standard'] = handler