--[[

	Elements handled:
	 .AutoShot [statusbar]
	 .AutoShot.Time [fontstring]

	Functions that can be overridden from within a layout:
	 - :OverrideAutoShot(startTime, endTime, currentTime)

--]]
local _, class = UnitClass('player'); if(class ~= 'HUNTER') then return end

local startTime, endTime, currentTime = 0, 0, 0
local GetTime, GetSpellInfo =
		GetTime, GetSpellInfo

function oUF:UNIT_SPELLCAST_SUCCEEDED(event, unit, spell, rank)
	if(unit ~= 'player' or spell ~= GetSpellInfo(75)) then return end

	startTime = GetTime()
	endTime = startTime + UnitRangedDamage('player')

	local autoshot = self.AutoShot
	autoshot:SetAlpha(1)
	autoshot:SetMinMaxValues(startTime, endTime)
end

local function OnUpdate(self)
	currentTime = GetTime()
	if(currentTime > endTime) then
		self:SetAlpha(0)
	else
		self:SetValue(startTime + (currentTime - startTime))

		if(self.Time) then
			if(self.OverrideAutoShot) then
				self:OverrideAutoShot(startTime, endTime, currentTime)
			else
				self.Time:SetFormattedText('%.1f', endTime - currentTime)
			end
		end
	end
end

oUF:RegisterInitCallback(function(self)
	local autoshot = self.AutoShot
	if(autoshot) then
		self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED')

		autoshot:SetScript('OnUpdate', OnUpdate)

		if(not autoshot:GetStatusBarTexture()) then
			autoshot:SetStatusBarTexture([=[Interface\TargetingFrame\UI-StatusBar]=])
		end
	end
end)